IMPLEMENTATION MODULE CALCOPERATION;

FROM RSTACKELEMENT
   IMPORT StackElement, Operators, IsInteger, GetInteger, GetReal,
          GetOperator, CreateInteger, CreateReal;


PROCEDURE Calculate (firstOperand,
                     CalcOperator,
                     secondOperand : StackElement) : StackElement;

TYPE opSet      = SET OF Operators;
VAR  IntegerOp  : BOOLEAN;
     IntResult  : INTEGER;
     firstReal,
     secondReal,
     RealResult : REAL;

BEGIN
   IF IsInteger (firstOperand) THEN
      IF IsInteger (secondOperand) THEN
         IF (GetOperator (CalcOperator) IN opSet{add,mul,sub}) THEN
            IntegerOp := TRUE
         ELSE
            IntegerOp := FALSE
         END (* IF *)
      ELSE
         IntegerOp := FALSE
      END (* IF *)
   ELSE
      IntegerOp := FALSE
   END (* IF *);
   IF IntegerOp THEN
      CASE GetOperator (CalcOperator) OF
         add : IntResult := GetInteger (firstOperand) + GetInteger (secondOperand)
      |  sub : IntResult := GetInteger (firstOperand) - GetInteger (secondOperand)
      |  mul : IntResult := GetInteger (firstOperand) * GetInteger (secondOperand)
      END (* CASE *);
      RETURN CreateInteger (IntResult)
   ELSE
      IF IsInteger (firstOperand) THEN
         firstReal := FLOAT (GetInteger (firstOperand));
         secondReal := GetReal (secondOperand)
      ELSIF IsInteger (secondOperand) THEN
         firstReal := GetReal (firstOperand);
         secondReal := FLOAT (GetInteger (secondOperand))
      ELSE
         firstReal := GetReal (firstOperand);
         secondReal := GetReal (secondOperand)
      END (* IF *);
      CASE GetOperator (CalcOperator) OF
         add : RealResult := firstReal + secondReal
      |  sub : RealResult := firstReal - secondReal
      |  mul : RealResult := firstReal * secondReal
      |  div : RealResult := firstReal / secondReal
      END (* CASE *);
      RETURN CreateReal (RealResult)
   END (* IF *)
END Calculate;

END CALCOPERATION.
